package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.OrderMessage;
import com.izouma.awesomeadmin.service.OrderMessageService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/orderMessage")
@RequiresAuthentication
public class OrderMessageController {

    @Autowired
    private OrderMessageService orderMessageService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(OrderMessage record) {
        List<OrderMessage> pp = orderMessageService.getOrderMessageList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getOrderMessage", method = RequestMethod.GET)
    @ResponseBody
    public Result getOrderMessage(@RequestParam(required = false, value = "id") String id) {
        OrderMessage data = orderMessageService.getOrderMessageById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(OrderMessage record) {
        OrderMessage data = orderMessageService.getOrderMessage(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, OrderMessage record) {
        Map<String, Object> result = new HashMap<>();

        List<OrderMessage> pp =orderMessageService.getOrderMessageByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(OrderMessage record) {
        boolean num = orderMessageService.createOrderMessage(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateOrderMessage(OrderMessage record) {
        boolean num = orderMessageService.updateOrderMessage(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteOrderMessage(@RequestParam(required = true, value = "id") String id) {

        boolean num = orderMessageService.deleteOrderMessage(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, OrderMessage record) throws Exception {

    List<OrderMessage> orderMessages = orderMessageService.getOrderMessageList(record);


        String sheetName = "order_message";
        String titleName = "订单留言数据表";
        String fileName = "订单留言表";
        int columnNumber = 12;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "订单" ,   "用户" ,   "店铺" ,   "客服" ,   "类型" ,   "留言"  };
        String[][] dataList = new String[orderMessages.size()][12];

        for (int i = 0; i < orderMessages.size(); i++) {

                        dataList[i][0] = String.valueOf(orderMessages.get(i).getId());
                        dataList[i][1] = String.valueOf(orderMessages.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(orderMessages.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(orderMessages.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(orderMessages.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(orderMessages.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(orderMessages.get(i).getOrderId());
                        dataList[i][7] = String.valueOf(orderMessages.get(i).getUserId());
                        dataList[i][8] = String.valueOf(orderMessages.get(i).getStoreId());
                        dataList[i][9] = String.valueOf(orderMessages.get(i).getServerId());
                        dataList[i][10] = String.valueOf(orderMessages.get(i).getTypeFlag());
                        dataList[i][11] = String.valueOf(orderMessages.get(i).getRemark());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

